<?php

class Engineering_Manufacturing_Customizer_Notify {

	private $config = array(); // Declare $config property
	
	private $engineering_manufacturing_recommended_actions;
	
	private $recommended_plugins;
	
	private static $instance;
	
	private $engineering_manufacturing_recommended_actions_title;
	
	private $engineering_manufacturing_recommended_plugins_title;
	
	private $dismiss_button;
	
	private $engineering_manufacturing_install_button_label;
	
	private $engineering_manufacturing_activate_button_label;
	
	private $engineering_manufacturing_deactivate_button_label;

	
	public static function init( $config ) {
		if ( ! isset( self::$instance ) && ! ( self::$instance instanceof Engineering_Manufacturing_Customizer_Notify ) ) {
			self::$instance = new Engineering_Manufacturing_Customizer_Notify;
			if ( ! empty( $config ) && is_array( $config ) ) {
				self::$instance->config = $config;
				self::$instance->setup_config();
				self::$instance->setup_actions();
			}
		}

	}

	
	public function setup_config() {

		global $engineering_manufacturing_customizer_notify_recommended_plugins;
		global $engineering_manufacturing_customizer_notify_engineering_manufacturing_recommended_actions;

		global $engineering_manufacturing_install_button_label;
		global $engineering_manufacturing_activate_button_label;
		global $engineering_manufacturing_deactivate_button_label;

		$this->engineering_manufacturing_recommended_actions = isset( $this->config['engineering_manufacturing_recommended_actions'] ) ? $this->config['engineering_manufacturing_recommended_actions'] : array();
		$this->recommended_plugins = isset( $this->config['recommended_plugins'] ) ? $this->config['recommended_plugins'] : array();

		$this->engineering_manufacturing_recommended_actions_title = isset( $this->config['engineering_manufacturing_recommended_actions_title'] ) ? $this->config['engineering_manufacturing_recommended_actions_title'] : '';
		$this->engineering_manufacturing_recommended_plugins_title = isset( $this->config['engineering_manufacturing_recommended_plugins_title'] ) ? $this->config['engineering_manufacturing_recommended_plugins_title'] : '';
		$this->dismiss_button            = isset( $this->config['dismiss_button'] ) ? $this->config['dismiss_button'] : '';

		$engineering_manufacturing_customizer_notify_recommended_plugins = array();
		$engineering_manufacturing_customizer_notify_engineering_manufacturing_recommended_actions = array();

		if ( isset( $this->recommended_plugins ) ) {
			$engineering_manufacturing_customizer_notify_recommended_plugins = $this->recommended_plugins;
		}

		if ( isset( $this->engineering_manufacturing_recommended_actions ) ) {
			$engineering_manufacturing_customizer_notify_engineering_manufacturing_recommended_actions = $this->engineering_manufacturing_recommended_actions;
		}

		$engineering_manufacturing_install_button_label    = isset( $this->config['engineering_manufacturing_install_button_label'] ) ? $this->config['engineering_manufacturing_install_button_label'] : '';
		$engineering_manufacturing_activate_button_label   = isset( $this->config['engineering_manufacturing_activate_button_label'] ) ? $this->config['engineering_manufacturing_activate_button_label'] : '';
		$engineering_manufacturing_deactivate_button_label = isset( $this->config['engineering_manufacturing_deactivate_button_label'] ) ? $this->config['engineering_manufacturing_deactivate_button_label'] : '';

	}

	
	public function setup_actions() {

		// Register the section
		add_action( 'customize_register', array( $this, 'engineering_manufacturing_plugin_notification_customize_register' ) );

		// Enqueue scripts and styles
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'engineering_manufacturing_customizer_notify_scripts_for_customizer' ), 0 );

		/* ajax callback for dismissable recommended actions */
		add_action( 'wp_ajax_quality_customizer_notify_dismiss_action', array( $this, 'engineering_manufacturing_customizer_notify_dismiss_recommended_action_callback' ) );

		add_action( 'wp_ajax_ti_customizer_notify_dismiss_recommended_plugins', array( $this, 'engineering_manufacturing_customizer_notify_dismiss_recommended_plugins_callback' ) );

	}

	
	public function engineering_manufacturing_customizer_notify_scripts_for_customizer() {

		wp_enqueue_style( 'engineering-manufacturing-customizer-notify-css', get_template_directory_uri() . '/core/includes/customizer-notice/css/engineering-manufacturing-customizer-notify.css', array());

		wp_enqueue_style( 'plugin-install' );
		wp_enqueue_script( 'plugin-install' );
		wp_add_inline_script( 'plugin-install', 'var pagenow = "customizer";' );

		wp_enqueue_script( 'updates' );

		wp_enqueue_script( 'engineering-manufacturing-customizer-notify-js', get_template_directory_uri() . '/core/includes/customizer-notice/js/engineering-manufacturing-customizer-notify.js', array( 'customize-controls' ));
		wp_localize_script(
			'engineering-manufacturing-customizer-notify-js', 'engineeringmanufacturingCustomizercompanionObject', array(
				'ajaxurl'            => admin_url( 'admin-ajax.php' ),
				'template_directory' => get_template_directory_uri(),
				'base_path'          => admin_url(),
				'activating_string'  => __( 'Activating', 'engineering-manufacturing' ),
			)
		);

	}

	
	public function engineering_manufacturing_plugin_notification_customize_register( $wp_customize ) {

		
		require_once get_template_directory() . '/core/includes/customizer-notice/engineering-manufacturing-customizer-notify-section.php';

		$wp_customize->register_section_type( 'Engineering_Manufacturing_Customizer_Notify_Section' );

		$wp_customize->add_section(
			new Engineering_Manufacturing_Customizer_Notify_Section(
				$wp_customize,
				'engineering-manufacturing-customizer-notify-section',
				array(
					'title'          => $this->engineering_manufacturing_recommended_actions_title,
					'plugin_text'    => $this->engineering_manufacturing_recommended_plugins_title,
					'dismiss_button' => $this->dismiss_button,
					'priority'       => 0,
				)
			)
		);

	}

	
	public function engineering_manufacturing_customizer_notify_dismiss_recommended_action_callback() {

		global $engineering_manufacturing_customizer_notify_engineering_manufacturing_recommended_actions;

		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html( $action_id ); /* this is needed and it's the id of the dismissable required action */ 

		if ( ! empty( $action_id ) ) {
			
			if ( get_option( 'engineering_manufacturing_customizer_notify_show' ) ) {

				$engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions = get_option( 'engineering_manufacturing_customizer_notify_show' );
				switch ( $_GET['todo'] ) {
					case 'add':
						$engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions[ $action_id ] = true;
						break;
					case 'dismiss':
						$engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions[ $action_id ] = false;
						break;
				}
				update_option( 'engineering_manufacturing_customizer_notify_show', $engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions );

				
			} else {
				$engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions = array();
				if ( ! empty( $engineering_manufacturing_customizer_notify_engineering_manufacturing_recommended_actions ) ) {
					foreach ( $engineering_manufacturing_customizer_notify_engineering_manufacturing_recommended_actions as $engineering_manufacturing_lite_customizer_notify_recommended_action ) {
						if ( $engineering_manufacturing_lite_customizer_notify_recommended_action['id'] == $action_id ) {
							$engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions[ $engineering_manufacturing_lite_customizer_notify_recommended_action['id'] ] = false;
						} else {
							$engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions[ $engineering_manufacturing_lite_customizer_notify_recommended_action['id'] ] = true;
						}
					}
					update_option( 'engineering_manufacturing_customizer_notify_show', $engineering_manufacturing_customizer_notify_show_engineering_manufacturing_recommended_actions );
				}
			}
		}
		die(); 
	}

	
	public function engineering_manufacturing_customizer_notify_dismiss_recommended_plugins_callback() {

		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html( $action_id ); /* this is needed and it's the id of the dismissable required action */

		if ( ! empty( $action_id ) ) {

			$engineering_manufacturing_lite_customizer_notify_show_recommended_plugins = get_option( 'engineering_manufacturing_customizer_notify_show_recommended_plugins' );

			switch ( $_GET['todo'] ) {
				case 'add':
					$engineering_manufacturing_lite_customizer_notify_show_recommended_plugins[ $action_id ] = false;
					break;
				case 'dismiss':
					$engineering_manufacturing_lite_customizer_notify_show_recommended_plugins[ $action_id ] = true;
					break;
			}
			update_option( 'engineering_manufacturing_customizer_notify_show_recommended_plugins', $engineering_manufacturing_lite_customizer_notify_show_recommended_plugins );
		}
		die(); 
	}

}
